org.springframework.batch.item.database.support

## Class SqlWindowingPagingQueryProvider

- java.lang.Object
- - org.springframework.batch.item.database.support.AbstractSqlPagingQueryProvider
  - - org.springframework.batch.item.database.support.SqlWindowingPagingQueryProvider

- All Implemented Interfaces:
    PagingQueryProvider
  Direct Known Subclasses:
    Db2PagingQueryProvider, DerbyPagingQueryProvider, SqlServerPagingQueryProvider, SybasePagingQueryProvider

      public class SqlWindowingPagingQueryProvider
      extends AbstractSqlPagingQueryProvider

  Generic Paging Query Provider using standard SQL:2003 windowing functions. These features are supported by DB2, Oracle, SQL Server 2005, Sybase and Apache Derby version 10.4.1.3
  Since:
    2.0
  Author:
    Thomas Risberg, Michael Minella

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SqlWindowingPagingQueryProvider()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Object` | `extractTableAlias()`
    `java.lang.String` | `generateFirstPageQuery(int pageSize)` Method generating the query string to be used for retrieving the first page.
    `java.lang.String` | `generateJumpToItemQuery(int itemIndex, int pageSize)` Method generating the query string to be used for jumping to a specific item position.
    `java.lang.String` | `generateRemainingPagesQuery(int pageSize)` Method generating the query string to be used for retrieving the pages following the first page.
    `protected java.lang.String` | `getOrderedQueryAlias()`
    `protected java.lang.String` | `getOverClause()`
    `protected java.lang.String` | `getOverSubstituteClauseEnd()`
    `protected java.lang.String` | `getOverSubstituteClauseStart()`
    `protected java.lang.Object` | `getSubQueryAlias()`

    - ### Methods inherited from class org.springframework.batch.item.database.support.AbstractSqlPagingQueryProvider

      `getFromClause, getGroupClause, getParameterCount, getSelectClause, getSortKeyPlaceHolder, getSortKeys, getSortKeysWithoutAliases, getWhereClause, init, isUsingNamedParameters, setFromClause, setGroupClause, setSelectClause, setSortKeys, setWhereClause`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SqlWindowingPagingQueryProvider

          public SqlWindowingPagingQueryProvider()

  - ### Method Detail

    - #### generateFirstPageQuery

          public java.lang.String generateFirstPageQuery(int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for retrieving the first page. This method must be implemented in sub classes.
      Specified by:
        `generateFirstPageQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateFirstPageQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `pageSize` - number of rows to read per page
      Returns:
        query string

    - #### getOrderedQueryAlias

          protected java.lang.String getOrderedQueryAlias()

    - #### getSubQueryAlias

          protected java.lang.Object getSubQueryAlias()

    - #### extractTableAlias

          protected java.lang.Object extractTableAlias()

    - #### generateRemainingPagesQuery

          public java.lang.String generateRemainingPagesQuery(int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for retrieving the pages following the first page. This method must be implemented in sub classes.
      Specified by:
        `generateRemainingPagesQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateRemainingPagesQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `pageSize` - number of rows to read per page
      Returns:
        query string

    - #### generateJumpToItemQuery

          public java.lang.String generateJumpToItemQuery(int itemIndex,
                                                          int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for jumping to a specific item position. This method must be implemented in sub classes.
      Specified by:
        `generateJumpToItemQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateJumpToItemQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `itemIndex` - the index of the item to jump to
        `pageSize` - number of rows to read per page
      Returns:
        query string

    - #### getOverClause

          protected java.lang.String getOverClause()

    - #### getOverSubstituteClauseStart

          protected java.lang.String getOverSubstituteClauseStart()

    - #### getOverSubstituteClauseEnd

          protected java.lang.String getOverSubstituteClauseEnd()